#include "encString.hpp"
#include <WiFiConfig.h>
#include <base64.h>
#include <libb64/cdecode.h>

#if defined(ESP8266)
# define ESP_getChipId() (ESP.getChipId())
#else
# include <esp_wifi.h>
# define ESP_getChipId() ((uint32_t)ESP.getEfuseMac())
#endif

void strEncode(String &str)
{

    const char *src = &str[0];
    uint8_t key[4];
    unsigned int enciphidx = 0;
    char c;
    unsigned int i;
    uint32_t cid = ESP_getChipId();
    uint32_t *pkey = (uint32_t *)&key[0];
    uint8_t data[str.length()];

    *pkey = cid;
    for (i = 0; i < str.length(); i++) {
        c = src[i];
        c ^= key[enciphidx];
        ++enciphidx;
        enciphidx %= sizeof(key);
        data[i] = c;
    }
#if defined(ESP8266)
    str = base64::encode(data, str.length(), false);
#else
    str = base64::encode(data, str.length());
#endif
}

void strDecode(String &str)
{

    const char *src = &str[0];
    uint8_t key[4];
    unsigned int enciphidx = 0;
    unsigned int i;
    uint8_t b;
    uint32_t cid = ESP_getChipId();
    uint32_t *pkey = (uint32_t *)&key[0];
    uint8_t data[str.length()];
    unsigned int clen = base64_decode_chars(src, str.length(), (char *)data);
    String result = F("");

    if (0 != clen) {
        *pkey = cid;
        for (i = 0; i < clen; i++) {
            b = data[i];
            b ^= key[enciphidx];
            ++enciphidx;
            enciphidx %= sizeof(key);
            result.concat(char(b));
        }
    }
    str = result;
}
